class WktimeController < ApplicationController
unloadable

include WktimeHelper

before_filter :require_login
before_filter :check_perm_and_redirect, :only => [:edit, :update]
before_filter :check_editperm_redirect, :only => [:destroy]

  def index
    retrieve_date_range	
	@from = getMonday(@from)
	@to = getSunday(@to)
	
    respond_to do |format|
      format.html {
        # Paginate results
		user_id = params[:user_id]
		set_user_projects
		ids = nil		
		if user_id.blank?
			ids = User.current.id.to_s
		elsif user_id.to_i == 0
			#all users
			@selected_project.members.each_with_index do|m, i|
				if i == 0
					ids =  m.user_id.to_s
				else
					ids +=  ',' + m.user_id.to_s
				end
			end		
			ids = User.current.id.to_s if ids.nil?
		else
			ids = user_id
		end
		# mysql - the weekday index for date (0 = Monday, 1 = Tuesday,  6 = Sunday)
		sqlStr = "select user_id, monday as spent_on, hours from " +
			" (select adddate(t.spent_on,weekday(t.spent_on)*-1) as monday, "
		
		# postgre doesn't have the weekday function
		# The day of the week (0 - 6; Sunday is 0)
		if ActiveRecord::Base.connection.adapter_name == 'PostgreSQL'
			sqlStr = "select user_id, monday as spent_on, hours from " +
				" (select case when cast(extract(dow from t.spent_on) as integer) = 0 then t.spent_on - 6" +
				" else t.spent_on - (cast(extract(dow from t.spent_on) as integer) - 1) end as monday, "
		elsif ActiveRecord::Base.connection.adapter_name == 'SQLite'
			sqlStr = "select user_id, monday as spent_on, hours from " +
				" (select date(spent_on, '-' || strftime('%w', spent_on, '-1 days') || ' days') as monday, "
		end
		sqlStr += " t.user_id, sum(t.hours) as hours from time_entries t, users u" +
			" where u.id = t.user_id and u.id in (#{ids})"
		sqlStr += " and t.spent_on between '#{@from}' and '#{@to}'" unless @from.blank? && @to.blank?
		sqlStr += " group by monday, user_id order by monday desc, user_id) as v1"	
		 
		result = TimeEntry.find_by_sql("select count(*) as id from (" + sqlStr + ") as v2")
		@entry_count = result[0].id
        @entry_pages = Paginator.new self, @entry_count, per_page_option, params['page']
			
		@entries = TimeEntry.find_by_sql(sqlStr + 
			" LIMIT " + @entry_pages.items_per_page.to_s +
			" OFFSET " + @entry_pages.current.offset.to_s)

        #@total_hours = TimeEntry.visible.sum(:hours, :include => [:user], :conditions => cond.conditions).to_f
		result = TimeEntry.find_by_sql("select sum(hours) as hours from (" + sqlStr + ") as v2")
		@total_hours = result[0].hours
        render :layout => !request.xhr?
      }
    end

  end

  def edit
	respond_to do |format|
		format.html {
			@prev_template = false
			@mon = params[:mon].to_s.to_date
			# if user has changed the monday
			@mon = getMonday(@mon)
			user_id = params[:user_id]
			cond = getCondition(@mon, user_id)
			@entries = findEntries()
			if @entries.blank? && !params[:prev_template].blank?
				@prev_entries = prevTemplate(user_id)
				@prev_template = true
			end
			render :layout => !request.xhr?
		} 
		format.api  {
		}
	end
  end

  # called when save is clicked on the page
  def update
  	respond_to do |format|
		format.html {
			gatherEntries
			set_loggable_projects
			errorMsg = nil
			TimeEntry.transaction do
				begin
					@entries.each do |entry|
						if entry.hours.blank?
							# delete the time_entry
							# if the hours is empty but id is valid
							# entry.destroy() unless ids[i].blank?
							if !entry.id.blank?
								if !entry.destroy()
									errorMsg = entry.errors.full_messages.join('\n')
									break
								end
							end
						else
							#if id is there it should be update otherwise create
							#the UI disables editing of 
							if can_log_time?(entry.project_id)
								if !entry.save()
									errorMsg = entry.errors.full_messages.join('\n')
									break
								end
							else
								errorMsg = l(:error_not_permitted_save)
								break
							end
						end
					end					
				rescue Exception => e			
					errorMsg = e.message
				end
				
				if errorMsg.nil?
					unless @entries.blank?
						flash[:notice] = l(:notice_successful_update)
					else
						flash[:notice] = l(:error_wktime_save_nothing)
					end
					#redirect_back_or_default :action => 'index'
					redirect_to :action => 'index'
				else					
					flash[:error] = l(:error_wktime_save_failed, errorMsg)	
					if !params[:enter_issue_id].blank? && params[:enter_issue_id].to_i == 1					
						redirect_to :action => 'edit', :user_id => params[:user_id], :mon => @mon,
						:enter_issue_id => 1	
					else
						redirect_to :action => 'edit', :user_id => params[:user_id], :mon => @mon
					end
					raise ActiveRecord::Rollback
				end
			end
		} 
		format.api  {
		}
	end  
  end
	
	def deleterow
		if check_editPermission
			ids = params['ids']
			TimeEntry.delete(ids)	
			respond_to do |format|
				format.text  { 
					render :text => 'OK' 
				}
			end
		else
			respond_to do |format|
				format.text  { 
					render :text => 'FAILED' 
				}
			end
		end
	end

	def destroy	
		respond_to do |format|
			format.html {
				@mon = params[:mon].to_s.to_date
				cond = getCondition(@mon, params[:user_id])
				TimeEntry.delete_all(cond)
				flash[:notice] = l(:notice_successful_delete)
				redirect_back_or_default :action => 'index'
			} 
			format.api  {
			}
		end
	end
	
	def new
		set_user_projects
		# get the monday for current week
		@mon = getMonday(Date.today)
		render :action => 'new'
	end
	
	
	
  def getissues
	if Setting.plugin_redmine_wktime['wktime_closed_issue_ind'].to_i == 1
		issues = Issue.find_all_by_project_id(params[:project_id] || params[:project_ids], :order => 'project_id')
	else
		issues = Issue.find_all_by_project_id(params[:project_id] || params[:project_ids],
		:conditions => ["#{IssueStatus.table_name}.is_closed = ? OR #{Issue.table_name}.updated_on >= ?", false, @mon],
		:include => :status, :order => 'project_id')
	end
	
	user = User.find(params[:user_id])
	
	issStr =""
	issues.each do |issue|
		issStr << issue.project_id.to_s() + ',' + issue.id.to_s() + ',' + 
				issue.subject + "\n" if issue.visible?(user)
	end
	respond_to do |format|
		format.text  { render :text => issStr }
	end
  end
  
	def getactivities
		project = nil
		error = nil
		project_id = params[:project_id]
		if !project_id.blank?
			project = Project.find(project_id)
		elsif !params[:issue_id].blank?
			issue = Issue.find(params[:issue_id])
			project = issue.project
			project_id = project.id
			u_id = params[:user_id]
			user = User.find(u_id)
			if !user_allowed_to?(:log_time, project)
				error = "403"
			end
		else
			error = "403"
		end
		actStr =""
		project.activities.each do |a|
			actStr << project_id.to_s() + ',' + a.id.to_s() + ',' + a.name + "\n"
		end
	
		respond_to do |format|
			format.text  { 
			if error.blank?
				render :text => actStr 
			else
				render_403
			end
			}
		end
	end
	
	def getusers
		project = Project.find(params[:project_id])
		userStr =""
		project.members.each do |m|
			userStr << m.user_id.to_s() + ',' + m.name + "\n"
		end
	
		respond_to do |format|
			format.text  { render :text => userStr }
		end
	end

  # Export wktime to a single pdf file
  def export
    respond_to do |format|
		format.pdf {
			@entries = findEntries()
			send_data(wktime_to_pdf(@entries, @user, @mon), :type => 'application/pdf', :filename => "#{@mon}-#{params[:user_id]}.pdf")
      }
    end
  end
	
private
	def getCondition(mon, user_id)
	['spent_on BETWEEN ? AND ? AND user_id = ?', mon, mon + 6, user_id]
	end
	
	#change the date to a monday
	def getMonday(date)
		unless date.nil?
			#the day of calendar week (1-7, Monday is 1)
			day1_diff = date.cwday%7 - 1
			#date -= day1_diff if day1_diff != 0
			date -= day1_diff == -1 ? 6 : day1_diff
		end
		date
	end

	#change the date to a sunday
	def getSunday(date)
		unless date.nil?
			day7_diff = 7 - date.cwday%7
			date += day7_diff == 7 ? 0 : day7_diff
		end
		date
	end
	
	def prevTemplate(user_id)
		# the weekday index for date (0 = Monday, 1 = Tuesday,  6 = Sunday)
		sqlStr = "select max(spent_on) as max_spent_on from time_entries" +
			" where user_id = " + user_id
		 
		result = TimeEntry.find_by_sql(sqlStr)
		prev_entries = nil
		max_spent_on = result[0].max_spent_on
		unless max_spent_on.blank?
			start = getMonday(max_spent_on.to_date)
			cond = getCondition(start, user_id)
			prev_entries = TimeEntry.find(:all, :conditions => cond,
					:order => 'project_id, issue_id, activity_id, spent_on')
		end
		prev_entries

	end

	
  def gatherEntries
		entryHash = params[:time_entry]
		@entries ||= Array.new
		@mon = params[:mon].to_s.to_date unless params[:mon].blank?
		decimal_separator = l(:general_csv_decimal_separator)
		custom_values = Hash.new
		custom_fields = TimeEntryCustomField.find(:all)
							
		unless entryHash.nil?
			entryHash.each_with_index do |entry, i|
				if !entry['project_id'].blank?
					hours = params['hours' + (i+1).to_s()]					
					ids = params['ids' + (i+1).to_s()]
					comments = params['comments' + (i+1).to_s()]
					disabled = params['disabled' + (i+1).to_s()]
					
					custom_values.clear

					custom_fields.each do |cf|
						custom_values[cf.id] = params["_custom_field_values_#{cf.id}" + (i+1).to_s()]
					end
					
					j = 0
					ids.each_with_index do |id, k|
						if disabled[k] == "false"
							if(!id.blank? || !hours[j].blank?)
								timeEntry = nil

								timeEntry = id.blank? ? TimeEntry.new : TimeEntry.find(id)								
								timeEntry.attributes = entry
								# since project_id and user_id is protected
								timeEntry.project_id = entry['project_id']
								timeEntry.user_id = params[:user_id]
								timeEntry.spent_on = @mon + k
								timeEntry.comments = comments[k].blank? ? nil : comments[k]								
								#timeEntry.hours = hours[j].blank? ? nil : hours[j].to_f
								#to allow for internationalization on decimal separator
								timeEntry.hours = hours[j].blank? ? nil : hours[j].gsub(decimal_separator, '.').to_f
								
								timeEntry.custom_field_values.each do |custom_value|
								#timeEntry.custom_values.each do |custom_value|
									custom_field = custom_value.custom_field

									#custom_values = params["_custom_field_values_#{custom_field.id}" + (i+1).to_s()]
									cvs = custom_values[custom_field.id]								
									custom_value.value = cvs[k].blank? ? nil : 
										custom_field.multiple? ? cvs[k].split(',') : cvs[k]									
								end
								
								@entries << timeEntry	
							end
							j += 1
						end				
					end
				end
			end
		end
  end

	def findEntries
		@mon = params[:mon].to_s.to_date
		# if user has changed the monday
		@mon = getMonday(@mon)
		user_id = params[:user_id]
		@user ||= User.find(user_id)
		cond = getCondition(@mon, user_id)
		TimeEntry.find(:all, :conditions => cond,
			:order => 'project_id, issue_id, activity_id, spent_on')
	end
  
	def render_edit
		set_user_projects
		render :action => 'edit', :user_id => params[:user_id], :mon => @mon
	end
	
  def check_perm_and_redirect
    unless check_permission
      render_403
      return false
    end
  end
  
  def user_allowed_to?(privilege, entity)
	u_id = params[:user_id]
	@user ||= u_id.blank? ? User.current : User.find(u_id)
	return @user.allowed_to?(privilege, entity)
  end
  
  def can_log_time?(project_id)
	ret = false
	set_loggable_projects
	@logtime_projects.each do |lp|
		if lp.id == project_id
			ret = true
			break
		end
	end
	return ret
  end
  
  def check_permission
	set_user_projects
    return !@logtime_projects.blank?
  end
  
    def check_editperm_redirect
		unless check_editPermission
			render_403
			return false
		end
	end
  
    def check_editPermission
		allowed = true;
		ids = params['ids']
		if !ids.blank?
			@entries = TimeEntry.find(ids)
		else
			@mon = params[:mon].to_s.to_date
			cond = getCondition(@mon, params[:user_id])
			@entries = TimeEntry.find(:all, :conditions => cond)
		end
		@entries.each do |entry|
			if(!entry.editable_by?(User.current))
				allowed = false
				break
			end
		end
		return allowed
	end
  
  # Retrieves the date range based on predefined ranges or specific from/to param dates
  def retrieve_date_range
    @free_period = false
    @from, @to = nil, nil

    if params[:period_type] == '1' || (params[:period_type].nil? && !params[:period].nil?)
      case params[:period].to_s
      when 'today'
        @from = @to = Date.today
      when 'yesterday'
        @from = @to = Date.today - 1
      when 'current_week'
        @from = Date.today - (Date.today.cwday - 1)%7
        @to = @from + 6
      when 'last_week'
        @from = Date.today - 7 - (Date.today.cwday - 1)%7
        @to = @from + 6
      when '7_days'
        @from = Date.today - 7
        @to = Date.today
      when 'current_month'
        @from = Date.civil(Date.today.year, Date.today.month, 1)
        @to = (@from >> 1) - 1
      when 'last_month'
        @from = Date.civil(Date.today.year, Date.today.month, 1) << 1
        @to = (@from >> 1) - 1
      when '30_days'
        @from = Date.today - 30
        @to = Date.today
      when 'current_year'
        @from = Date.civil(Date.today.year, 1, 1)
        @to = Date.civil(Date.today.year, 12, 31)
      end
    elsif params[:period_type] == '2' || (params[:period_type].nil? && (!params[:from].nil? || !params[:to].nil?))
      begin; @from = params[:from].to_s.to_date unless params[:from].blank?; rescue; end
      begin; @to = params[:to].to_s.to_date unless params[:to].blank?; rescue; end
      @free_period = true
    else
      # default
	  # 'current_month'		
        @from = Date.civil(Date.today.year, Date.today.month, 1)
        @to = (@from >> 1) - 1
    end    
    
    @from, @to = @to, @from if @from && @to && @from > @to

  end  

	def set_user_projects
		set_managed_projects
		set_loggable_projects
	end
	
	def set_managed_projects
		@manage_projects ||= Project.find(:all, :order => 'name', 
			:conditions => Project.allowed_to_condition(User.current, :manage_members))
		selected_proj_id = params[:project_id]
		if !selected_proj_id.blank?
			sel_project = @manage_projects.select{ |proj| proj.id == selected_proj_id.to_i }	
			@selected_project ||= sel_project[0] if !sel_project.blank?
		else
			@selected_project ||= @manage_projects[0] if !@manage_projects.blank?
		end
	end

	def set_loggable_projects
		u_id = params[:user_id]
		if !u_id.blank?	&& u_id.to_i != 0
			@user ||= User.find(u_id)			
			@logtime_projects ||= Project.find(:all, :order => 'name', 
				:conditions => Project.allowed_to_condition(@user, :log_time))
		end
	end

end